{
Custom Characters 2.3

(C) 1993 Steve Goldsmith
All Rights Reserved

Character set dialog used to display .PCX files.  Foreground color must
have bit 3 set (colors 8 - 15) to display the second VGA font which CC.PAS
uses to display graphics.  You can use any window size as long as the total
characters is <= 256 (X*Y <= 256).  See PCX.PAS, CHRPCX.PAS for more info
on encoding and decoding .PCX files.  See VGA.PAS for more info on
accessing font memory.
}

unit ChSetDlg;

{$I APP.INC}

interface

uses

  DOS,
  Objects, App, Views, Dialogs, Drivers,
  MsgBox,
  VGA, ChrPCX;

type

  PChrSetView = ^TChrSetView;
  TChrSetView = object(TView)
    procedure Draw; virtual;
  end;

  PChrSetDlg = ^TChrSetDlg;
  TChrSetDlg = object (TDialog)
    constructor Init (Name : PathStr; XLen,YLen : word);
    function GetPalette: PPalette; virtual;
  end;

const

  CGraphColor = #$00; {dialog palette additions for graphics color}
  CGraphPal   = #143;

implementation

procedure TChrSetView.Draw;

var

  Buf: TDrawBuffer;
  X, Y: Integer;
  Color: word;

begin
  Color := GetColor(33); {color added after last dialog entry}
  for Y := 0 to Size.Y - 1 do {draw character set to fit view}
  begin
    for X := 0 to Size.X - 1 do
      Buf[x] := (Y*Size.X+X) or (Color shl 8);
    WriteBuf (0,Y,Size.X,1,Buf);
  end
end;

{TChrSetDlg}

constructor TChrSetDlg.Init (Name : PathStr; XLen,YLen : word);

var

  R : TRect;

begin
  R.Assign (0,0,XLen+2,YLen+2); {leaves room for view of xlen,ylen}
  inherited Init (R,Name);
  GetExtent(R);
  R.Grow(-1,-1);
  Insert(New(PChrSetView, Init(R)))
end;

function TChrSetDlg.GetPalette: PPalette;

const

  CNewBlueDialog = CBlueDialog+CGraphPal;
  CNewCyanDialog = CCyanDialog+CGraphPal;
  CNewGrayDialog = CGrayDialog+CGraphPal;
  P: array[dpBlueDialog..dpGrayDialog] of string[Length(CNewBlueDialog)] =
    (CNewBlueDialog, CNewCyanDialog, CNewGrayDialog);

begin {get graphic color addition to dialog palette}
  GetPalette := @P[Palette];
end;

end.
