unit myutils;

interface

uses crt, graph;

type
 goodchars = set of char;

const
 ynchars : goodchars = ['y','Y','n','N'];
 backspace = #8;
 enter = #13;
 space = #32;
 x : integer = 10;
 y : integer = 10;
 lmargin = 10;

type string80 = string[80];

procedure drawcombox;
procedure pause;
procedure getgoodchar(goodones :goodchars; var inchar :char);
procedure getgoodint(minnum, maxnum :integer; var innum : integer);
procedure gfilesloc(var gdriver, gmode:integer; gpath :string);
procedure homecursor(var x,y :integer);
procedure gwrite(var x,y :integer; gtext :string);
procedure gwriteln(var x,y :integer; gtext :string);
procedure gpause;
procedure gpausexy(var x,y :integer);
procedure gread(var x,y :integer; var gtext : string);
procedure drprscr;


implementation

 var
   gdriver,
   gmode,
   maxx,
   maxy : integer;
   gtext : string;


procedure drprscr;

 begin
  gotoxy(32,1);
  textcolor(11);
  textbackground(black);
  write('EMPLOYEE PROFILE');
  textcolor(13);
  gotoxy(2,4);
  write('Emp Code  :');
  gotoxy(2,5);
  textcolor(15);
  write('Name:     :');
  gotoxy(2,6);
  textcolor(13);
  write('D.O.B     :');
  gotoxy(2,7);
  textcolor(15);
  write('Address   :');
  gotoxy(2,8);
  textcolor(13);
  write('City      :');
  gotoxy(2,9);
  textcolor(15);
  write('State     :');
  gotoxy(2,10);
  textcolor(13);
  write('Zip Code  :');
  gotoxy(2,11);
  textcolor(15);
  write('S.S #.    :');
  gotoxy(40,4);
  textcolor(13);
  write('Home Ph.  :');
  gotoxy(40,5);
  textcolor(15);
  write('Emer. Ph. :');
  gotoxy(40,6);
  textcolor(13);
  write('Hire Date :');
  gotoxy(40,7);
  textcolor(15);
  write('Lic. #    :');
  gotoxy(40,8);
  textcolor(13);
  write('Lic. Exp. :');
  gotoxy(40,9);
  textcolor(15);
  write('Ph. Exp.  :');
  gotoxy(40,10);
  textcolor(13);
  write('Rehirable :');
  gotoxy(40,11);
  textcolor(15);
  write('Notify    :');
  gotoxy(2,13);
  textcolor(12);
  write('Vacation  :');
  gotoxy(2,14);
  textcolor(14);
  write('Insurance :');


end;



procedure drawcombox;

var
counter: integer;

begin
 counter := 1;
 textcolor(11);
 textbackground(black);
 gotoxy(36,17);
 writeln('COMMENTS');
 gotoxy(4,18);
 writeln(' ͻ');
 while counter <4 do
 begin
   writeln('    ',counter,'.','                                                                    ');
   counter := counter +1;
 end;
 writeln('    ͼ');
end;

procedure pause;

var
 proceed : char;

begin
   writeln;
   writeln('Press any key ');
   proceed := readkey;
   writeln;writeln
 end;

procedure getgoodchar(goodones :goodchars; var inchar: char);

 var
   markx, marky :byte;

 begin
   repeat
     begin
       markx := wherex;
       marky := wherey;
       readln(inchar);
       if not (inchar in goodones) then
         begin
           gotoxy(markx, marky);
           clreol
         end
     end
   until inchar in goodones
  end;

 procedure getgoodint(minnum, maxnum :integer; var innum : integer);

 var
   markx, marky :byte;
   loopcontrol : integer;

 begin
   repeat
     begin
       markx := wherex;
       marky := wherey;
       {$I-}
       readln(innum);
       {$I+}
       loopcontrol := ioresult;
       if (loopcontrol <> 0) then
         begin
           gotoxy(markx, marky);
           clreol
         end;
       if (innum < minnum) or (innum > maxnum) then
         begin
           gotoxy(markx,marky);
           clreol
         end
       end
     until (loopcontrol = 0) and ( innum >= minnum) and (innum <= maxnum)
   end;

procedure gfilesloc(var gdriver, gmode:integer; gpath :string);

  var
    gerror : integer;
    tpath : string;

  const
   etpath = 'c:\tp\bgi';

  begin
    clrscr;
    repeat
      gdriver := detect;
      initgraph(gdriver,gmode,etpath);
      gerror := graphresult;
      if (gerror <> 0) then
        begin
          writeln('Graphics error: ', grapherrormsg(gerror));
          if gerror = grfilenotfound
          then
          begin
            writeln('Cannot find graphics driver. Please');
            writeln('enter the correct directory path: ');
            readln(gpath);
            writeln
          end
        else halt(1)
      end
    until gerror = grok;
  end;

procedure homecursor(var x,y :integer);
  begin
    x := 10;
    y := 10;
  end;

procedure gwrite(var x,y : integer; gtext :string);
  begin
    outtextxy(x,y,gtext);
    x:= x+textwidth(gtext);
  end;

procedure gwriteln(var x,y :integer; gtext :string);
  begin
    outtextxy(x,y, gtext);
    y := y + textheight('M');
    x := lmargin;
  end;

procedure gpause;

 var
   ch:char;

 begin
   settextjustify(lefttext, toptext);
   gwriteln(x,y, '');
   gwriteln(x,y, 'Press any key ...');
   repeat until keypressed;
   ch := readkey;
   gwriteln(x,y, '');
 end;

procedure gpausexy(var x,y : integer);

 var
   ch :char;

 begin
   settextstyle(triplexfont, horizdir, 2);
   settextjustify(lefttext, toptext);
   gwriteln(x,y, '');
   gwriteln(x,y, 'Press any key ...');
   repeat until keypressed;
   ch := readkey;
   gwriteln(x,y, '');
 end;

procedure gread(var x,y :integer; var gtext :string);

 var
   ch : char;
   valid :boolean;

 begin
   valid := true;
   gtext := '';
   repeat
   ch := readkey;
   if (ch <> enter) and valid then
   begin
     if (ch > chr(30)) or (ch < chr(39)) then
     begin
       valid := false;
       gwrite(x,y,'INVALID CHOICE TRY AGAIN');
     end
     else
     begin
     gwrite(x,y, ch);
     gtext := gtext + ch
     end
     end;
   until ch = enter
 end;

end.
