{                                                                         }
{  Copywrite 1993 Mark Dignam - Omen Computer Services - Perth Omen BBS.  }
{  This program ,including the source code MAY not be modified, changed   }
{  or altered in any way without written permission of the author.        }
{                                                                         }
{ Protocol Engine Main Module

     History

     V0.00          The Idea is Born!

     v0.12          The first beta version is released in Perth.
                    Looks good so far!
                    No Sealink yet
                    Gotta modidfy Yapp, and make it work with Paket.

     v0.13          Started to put in Sealink TX! What a pain.
                    Numberoffiles now reflects how many succesful files
                    Fixed Zmodem send with TX buffers

     v0.14          First Real Beta release, worldwide.
                    Fixed TINY bug in Zmodem Start - Mailers refused to
                    auto_download.

     v0.15          Added hooks for StartFile,EndFile and Everyblock.
                    Added linked list code for Filename passing.
                    Fixed Bug (not really my bug!) with transfers into Front
                    Door, because FD can't handle ZDLE Escaped $7f,$ff  (as
                    per Zmodem specs! Tich Tich Joho!)
                    Added WindowType Flag.

     v0.16          Minor cosmetic bug fixes. Fixed MAJOR bug in comm unit
                    for 16650 support!

     v0.17          Re_Wrote XModem code, allowing Sealink to be put in.
                    Ended up being tighter and easier to debug!
                    Added Dv Time Giveaway. Added CPS in window (waste of CPU!)

     v0.18          Finally Finished! First Decent Release... I Think!
                    Fixed annoying buglets in Timing at end of files, when
                    using high speeds modems + big fossil buffers.

     v0.19          Fixed HUGE bug that i left in the timerset routine. It
                    worked fine on AT's - but didn't work at ALL on Xt's. Some
                    idiot used a Bios call to the RTC, not the Dos Clock! This
                    ended up with Time1.obj being removed, and the code being
                    put in some "inline" asm.
                    Also made minor changes to ZmodemRx - a bit tighter on
                    a bad frame, and better detection for carrier change.
                    Added code for detecting and releasing time to OS2. Thanks
                    to Richard Stocks for this...
                    Moved the MultiTasker code into a separate unit so it
                    could be linked into the Comms unit easily.

     v0.20          Added ReceiveIt var to StartofFile External Hook. This
                    allows a skip/abort from the External hook subroutine.

     v0.21          fixed buglet in GetZfile, when receiving a file in 'zmodem
                    recovery', it wouldn't pick up the Zeof. Thanks to Walter
                    Schick for finding this one.
                    Added Carrier Changed logic to TimedRead, so it returns a
                    Timeout if carrier lost.
                    Fixed MAJOR bug with Zack in Zmodemrx. If sender requested
                    a Zack, the NEXT block would fail CRC. It also wasn't
                    handling Zcrcw correctly, and treated them as Zrpos's,
                    making transfer go slllloooowww. Thanks to Gary Raymond
                    for this one.
                    Added Bar graph in transfer window. Cosmetics only, adds
                    NOTHING to working, but too many people have asked for it.

    v0.22           Added ProtLang.pas to the code. This is the message file for
                    the Engine. All the messages that get displayed on the
                    screen are in here, and may be changed to suit the local
                    language.
                    Fixed small bug in the SendXfile procedure, where some
                    variables were not being initilized correctly. Caused
                    random errors with batch transfers in Sealink and Ymodem.

    v0.23           Changed Protlang.pas into a Unit, which can then be changed
                    and re-compiled when using only the shareware and the
                    registered units.
                    Added more cosmetics, "Time To Completion", in the
                    transfer window. Swapped the position of the filename and
                    filepath to make the window look a bit neater.
                    Removed "WindowCps" procedure, as it was almost a duplicate
                    of the data in WindowBarGraph.

    v0.24           Changed "TimedRead", as it couldn't keep up at 19200 baud
                    on a 12mhz AT. Now it checks the UART first, and returns
                    with byte if found, otherwise starts its countdown routine.
                    I never knew adding Longints took so long!
                    Fixed small bug in GetZHexByte, which MAY cause a range
                    check error.
                    Fixed small error in ZGetFile, which allowed a null file
                    name, now responds with a Zskip.

    v0.25           Changed ZmodemSend to abort on 4 Can's rxed, not 9! This
                    was the primary reason why it wasn't seeing aborts from
                    the remote end.
                    Added code at startup of ShareWare version to avoid "nasty"
                    persons stopping the copyright message coming up.

}


Unit ProtEng;

{$DEFINE Proteng}   {This will make ProtComm link into ProtTask}

INTERFACE

uses crt,dos,protcomm,prottask,protlang;

{ This unit MUST use its own serial driver. It has very efficent i/o buffering }
{ but it will use a fossil, if one is found at run time.                       }

Type
   Str64    = String[64];             {A type which is used everywhere within  }
                                      {ProtEng for the passing of filenames    }

  _StartFile  = Procedure(Fname : str64; FSize : Longint; Var Receiveit : Boolean);
  _EveryBlock = Procedure(CurrentOffset : Longint);
  _EndFile    = Procedure(Fname : Str64; GoodTransfer : Boolean);

{ External Procedure Hooks. These are the prototypes for the calls that will be }
{ made by the Protocol Engine at these times                                   }

Const
   MaxZBlockSize : Word = 1024;
   MaxRetrys     : Byte = 10;
   Version       = 'v0.25';
   CopyMessage   = '(c) 1993 Mark Dignam, 3:690/660.0@fidonet';

{ MaxZblockSize is the biggest Zmodem block to send. Most mailers can accept   }
{ 8k blocks, however Terminal programs usually only handle 1k blocks           }

{ MaxRetrys is the number of errors in any one transfer that will force a      }
{ error abort                                                                  }

Var
    OverWrite       : Boolean;        {Can overwrite on Rx                     }
    StartOfFile     : _StartFile;     {Called at start of EVERY file           }
    EveryBlock      : _EveryBlock;    {Called before every block transferred   }
    EndOfFile       : _EndFile;       {Called after every file, good or bad    }
    NumberOfFiles   : Byte;           {How many files got rxed/txed            }
    UploadPath      : Str64;          {Where to put the files. In Batch mode   }
                                      {this must be set to the upload directory}
                                      {for a single file mode, such as Xmodem  }
                                      {this string contains the FULL filename  }
    WindowType      : Byte;           {This byte controls the type of display  }
                                      {during a file transfer. It can be one of}
                                      {three values    0  = No Display         }
                                      {                1  = Window display     }
                                      {                2  = Plain Line_of_text }


Function Xmodemrx       : Boolean;
Function XmodemTX       : Boolean;
Function Xmodem1kTX     : Boolean;
Function Xmodem1kRx     : Boolean;
Function YmodemTX       : Boolean;
Function YmodemGTX      : Boolean;
Function YappRX         : Boolean;
Function YappTx         : Boolean;
Function YmodemRx       : Boolean;
Function YmodemGRX      : Boolean;
Function SealinkTx      : Boolean;
Function SealinkRx      : Boolean;
Function ZmodemTX       : Boolean;
Function ZmodemRX       : Boolean;

Function AddNametoList(Var Fname : Str64): Boolean;

{ Adds a Filename to the linked list. Will return false if not enough memory   }
{ to store the name                                                            }

Procedure GetNameFromList(Var Fname : Str64; var MoreFiles : Boolean);

{ Retreives and removes the first name from the linked list. Also returns      }
{ back if there any more names in the linked list. Fname will be empty if      }
{ no name found. It also returns any memory freed back to the heap             }

Procedure ClearNameList;

{ Clears the linked list and returns memory to the heap                        }

Implementation

{$I Protcon.pas}         { Types and Constants.... }

var
    workfile               : file;         { File used for most I/O       }
    sector                 : BigPoint;     { data buffer used for most i/o}
    Windir,                                { Direction of transfer        }
    Dummy1,                                { Just a Dummy Boolean         }
    Zfdx,                                  { Can the remote handle Duplex }
    ZDIo,                                  { Serial + Disk I/O interleaved}
    Zbrk,                                  { Can remote handle break      }
    StartCarrier,                          { State of Carrier at start    }
    CrcMode,                               { Crc/Checksum Mode            }
    Crc32Mode              : Boolean;      { Crc32/Crc16 Mode             }
    Aframe                 : Zframe;       { Default buffer for Zframes   }
    Crc,                                   { Current 16 Bit CRC value     }
    Zbuflen                : word;         { Length of Zmodem Buffer      }
    Crc32,                                 { Current 32 Bit CRC Value     }
    CurrentBaud            : Longint;      { Current Baud Rate            }
    sr                     : SearchRec;    { Dir rec used for file check  }
    scrbuff,                               { Holds screen data            }
    savescreen             : scrprt;       { For Window screens           }
    Currentfile,                           { Current file number          }
    OldX,Oldy,                             { Holds old cursur for windows }
    OldText,i              : Byte;         { Text Attribute plus a spare  }
    Regs                   : Registers;    { the dreaded Registers type   }
    first_ptr,                             { First Fname on Heap          }
    Currentptr             : filenamesptr; { Last FName on heap           }
    CurrentFName           : Str64;        { Name of current file         }
    temp                   : String;       { and a spare string           }

{$I protbits.pas}                          { bits and pieces - support routines}
{$I protwin.pas}                           { Window routines                   }
{$I protxys.pas}                           { XModem/Ymodem/Sealink Routines    }
{$I protyapp.pas}                          { Yapp routines                     }
{$I protzmod.pas}                          { Zmodem routines                   }

Begin

{
  Most of this code can be deleted if you wish! Its only my protection
  against pirate copys!!!
}

{$IFDEF debug}
  SetDown;
{$ENDIF}
{$IFDEF Demo}
  AssignCrt(output);
  rewrite(output);
  ClrScr;
  Temp := '';
  for i := 1 to length(MyNameEncoded) do
       MyNameEncoded[i] := chr(ord(MyNameEncoded[i]) Xor (i + 2));
   Writeln('Protocol Engine ',version,' Shareware Version - UNREGISTERED.');
   Writeln(MyNameEncoded);
  If Myname <> MyNameEncoded then
     begin
       Writeln(#7#7,'Security Breach!',#7#7,' An Attempt has been made to remove the ');
       writeln('Copyright Notice from this copy of the Protocol Engine');
       Writeln;
       Writeln('This is ONLY a demo version for your personal evaluation');
       Writeln('If I was a nasty programmer - i might even have erased your hard disk!');
       writeln;
       Halt(255);
     end;
 {$ENDIF}

{ Set Default Vars and make sure External hooks point internally }

  StartofFile := DummyStartofFile;         {Hooks!}
  EndofFile   := DummyEndOfFile;
  EveryBlock  := DummyEveryBlock;
  CurrentPtr := NIL;
  First_Ptr := Nil;
  ClearNameList;                           {Make sure file list is empty}
  OverWrite := false;                      {turn overwrite off          }
  Windowtype := 1;                         {default to window screen    }
  UploadPath := '';                        {and clear Uploadpath        }
end.

