{
Custom Characters 2.3

(C) 1993 Steve Goldsmith
All Rights Reserved

Color VGA low level access routines.  Check display type before using any
VGA dependent routines!  If you don't know how to program the VGA display
then be extra careful!  Some settings could harm your VGA display!
}

unit VGA;

{$I APP.INC}

interface

uses

  Memory;

const

{color vga index and data ports}

  vgaAttrIndex          = $03c0;
  vgaAttrData           = $03c1;
    vgaAttrMode           = $10;
    vgaAttrOverscan       = $11;
    vgaAttrCPEnable       = $12;
    vgaAttrHorzPelPan     = $13;
    vgaAttrColorSel       = $14;
  vgaMiscOutWrite       = $03c2;
  vgaSeqIndex           = $03c4;
    vgaSeqReset           = $00;
    vgaSeqClockMode       = $01;
    vgaSeqMapMask         = $02;
    vgaSeqChrMapSel       = $03;
    vgaSeqMemMode         = $04;
  vgaDACPelMask         = $03c6;
  vgaDACRead            = $03c7;
  vgaDACWrite           = $03c8;
  vgaDACPelData         = $03c9;
  vgaMiscOutRead        = $03cc;
  vgaGraphIndex         = $03ce;
    vgaGraphReset         = $00;
    vgaGraphEnable        = $01;
    vgaGraphColorCmp      = $02;
    vgaGraphFuncSel       = $03;
    vgaGraphReadMap       = $04;
    vgaGraphMode          = $05;
    vgaGraphMisc          = $06;
    vgaGraphDontCare      = $07;
    vgaGraphBitMask       = $08;
  vgaCRTIndex           = $03d4;
    vgaCRTHorzTotal       = $00;
    vgaCRTHorzDispEnd     = $01;
    vgaCRTStartHorzBlank  = $02;
    vgaCRTEndHorzBlank    = $03;
    vgaCRTStartHorzRescan = $04;
    vgaCRTEndHorzRescan   = $05;
    vgaCRTVertTotal       = $06;
    vgaCRTOverflow        = $07;
    vgaCRTVertPelPan      = $08;
    vgaCRTMaxScanLine     = $09;
    vgaCRTCurStart        = $0a;
    vgaCRTCurEnd          = $0b;
    vgaCRTStartAddrHi     = $0c;
    vgaCRTStartAddrLo     = $0d;
    vgaCRTCurLocHi        = $0e;
    vgaCRTCurLocLo        = $0f;
    vgaCRTStartVertRescan = $10;
    vgaCRTEndVertRescan   = $11;
    vgaCRTVertDispEnd     = $12;
    vgaCRTOffset          = $13;
    vgaCRTUnderlineLoc    = $14;
    vgaCRTStartVertBlank  = $15;
    vgaCRTEndVertBlank    = $16;
    vgaCRTModeControl     = $17;
    vgaCRTLineCompare     = $18;
  vgaCRTStatus          = $03da;

{256 color palette}

  vgaRGBMax      = 2;
  vgaDACRegMax   = 255;
  vgaPaletteSize = 768;
  vgaFadeInc     = 4;   {fade in/out increment}

{25 line vga text screen offsets and addrs}

  vgaPageOfsLoc : array[0..7] of word =
  ($0000,$0800,$1000,$1800,$2000,$2800,$3000,$3800);

  vgaPageLoc : array[0..7] of pointer =
  (
  Ptr ($b800,$0000),Ptr ($b800,$1000),Ptr ($b800,$2000),
  Ptr ($b800,$3000),Ptr ($b800,$4000),Ptr ($b800,$5000),
  Ptr ($b800,$6000),Ptr ($b800,$7000)
  );

  vgaScrWidth = 80;
  vgaScrSize25 = 2000;
  vgaScrSize50 = 4000;

{character generator/fonts}

  vgaMaxChrHeight = 32;
  vgaMaxChrs      = 256;
  vgaChrTableSize = 8192;

{info byte used by bios int 10h, func 11h, subfunc 30h}

  vgaRom8x14    = 2; vgaRom8x8     = 3; vgaRomAlt8x8  = 4;
  vgaRomAlt9x14 = 5; vgaRom8x16    = 6; vgaRomAlt9x16 = 7;

{vga character table locations}

  vgaChrTableLoc : array[0..7] of pointer =
  (
  Ptr ($a000,$0000),Ptr ($a000,$4000),Ptr ($a000,$8000),
  Ptr ($a000,$c000),Ptr ($a000,$2000),Ptr ($a000,$6000),
  Ptr ($a000,$a000),Ptr ($a000,$e000)
  );

{vga character map select settings}

  vgaChrTableMap1 : array[0..7] of byte =
  ($00,01,$02,$03,$10,$11,$12,$13);
  vgaChrTableMap2 : array[0..7] of byte =
  ($00,$04,$08,$0c,$20,$24,$28,$2c);

{codes returned by bios for active and passive video cards}

  vgaNoCard   =  0; vgaMDAMDA    =  1; vgaCGACGA   = 2; vgaEGAEGA  =  4;
  vgaEGAMDA   =  5; vgaVGAMono   =  7; vgaVGAColor = 8; vgaMCGACGA = 10;
  vgaMCGAMono = 11; vgaMCGAColor = 12;

  vgaDataBufMax = 65519;

type

  vgaDataBufPtr = ^vgaDataBuf;
  vgaDataBuf = array[0..vgaDataBufMax] of byte;
  vgaPalettePtr = ^vgaPalette;
  vgaPalette = array[0..vgaDACRegMax,0..vgaRGBMax] of byte;
  vgaChrTablePtr = ^vgaChrTable;
  vgaChrTable = array [0..vgaChrTableSize-1] of byte;

{low level vga port access}

procedure SetSeqCont (IndexReg, DataReg : byte);
function GetSeqCont (IndexReg : byte) : byte;
procedure SetCRTCont (IndexReg, DataReg : byte);
function GetCRTCont (IndexReg : byte) : byte;
procedure SetGraphCont (IndexReg, DataReg : byte);
function GetGraphCont (IndexReg : byte) : byte;
procedure SetAttrCont (IndexReg, DataReg : byte);
function GetAttrCont (IndexReg : byte) : byte;
procedure SetMiscOutput (DataReg : byte);
function GetMiscOutput : byte;

{screen oritnted routines using low level access}

procedure WaitVertSync;
procedure WaitDispEnable;
procedure SetChrWidth8;
procedure SetChrWidth9;
function IsChrWidth9 : boolean;
procedure SetPage (StartOfs : word);
procedure CopyScrMem (Src, Dest : pointer; Len : word);

{256 color dac routines using low level access}

procedure SetDAC (RegNum, R, G, B : byte);
procedure GetDAC (RegNum : byte; var R, G, B : byte);
procedure SetDACBlock (PalPtr : pointer; StartReg, RegCnt : word);
procedure GetDACBlock (PalPtr : pointer; StartReg, RegCnt : word);
procedure FadeOutDAC;
procedure FadeInDAC (DefPal : vgaPalettePtr);

{character generator routines using low level access}

procedure AccessFontMem;
procedure AccessScreenMem;
procedure FontMapSelect (Font1, Font2 : byte);
procedure FontMapVal (MapSel : byte; var Font1, Font2 : byte);
procedure FontTableLoc (MapSel : byte; var Font1Ptr, Font2Ptr : pointer);
procedure SetRamTable (StartChr,TotalChrs,Height : word;
                       BufAddr, ChrAddr : vgaChrTablePtr);
function GetRamTable (StartChr,TotalChrs,Height : word;
                      ChrAddr : vgaChrTablePtr) : vgaChrTablePtr;
procedure SetTablePix (X,Y,XLen,Height : word;
                       ChrAddr : vgaChrTablePtr; PixOn : boolean);
procedure DrawTableLine (X1,Y1,X2,Y2,XLen,Height : integer;
                         ChrAddr : vgaChrTablePtr; PixOn : boolean);
procedure DrawTableCircle (XC,YC,R,XLen,Height : integer;
                           ChrAddr : vgaChrTablePtr; PixOn : boolean);

{routines using vga bios}

function VGACardActive : boolean;

{attribute controller and 256 color dac routines using bios}

procedure BiosSetPalReg (RegNum, RegData : byte);
function BiosGetPalReg (RegNum : byte) : byte;
procedure BiosSetDAC (RegNum, R, G, B : byte);
procedure BiosGetDAC (RegNum : byte; var R, G, B : byte);
procedure BiosSetDACBlock (PalPtr : pointer; StartReg, RegCnt : word);
procedure BiosGetDACBlock (PalPtr : pointer; StartReg, RegCnt : word);

{character generator routines using bios}

procedure BiosFontMapSelect (Font1, Font2 : byte);
function BiosGetChrHeight : byte;
function BiosGetRomTablePtr (Info : byte) : pointer;
function BiosCopyRomTable (Info : byte) : vgaChrTablePtr;
procedure BiosSetChrTable (ChrTable : byte);
procedure BiosLoadFont (ChrData : pointer; ChrTable, ChrHeight :byte;
                        StartChr, NumChrs : word);
procedure BiosSetFont (ChrData : pointer; ChrTable, ChrHeight :byte;
                       StartChr, NumChrs : word);
procedure BiosLoad8X8Font (ChrTable : byte);
procedure BiosLoad8X14Font (ChrTable : byte);
procedure BiosLoad8X16Font (ChrTable : byte);
procedure BiosSet8X8Font (ChrTable : byte);
procedure BiosSet8X14Font (ChrTable : byte);
procedure BiosSet8X16Font (ChrTable : byte);

implementation

end.
